/*
* Portions of this file Copyright 1999-2005 University of Chicago
* Portions of this file Copyright 1999-2005 The University of Southern California.
*
* This file or a portion of this file is licensed under the
* terms of the Globus Toolkit Public License, found at
* http://www.globus.org/toolkit/download/license.html.
* If you redistribute this file, with or without
* modifications, you must include this notice in the file.
*/
package org.globus.mds.usefulrp.rpprovider;

import org.w3c.dom.Element;

/** 
 *  This interface defines a method that will output a DOM element for the use with 
 *  Resource Property providers.  The method will be invoked periodically
 *  in order to generate data for the value(s) of a Resource Property provider.
 */

public interface ResourcePropertyElementProducer
{
 /** Generate a DOM Element that can be used as a value of a Resource Property
  *
  * @param args An string argument vector to be passed as parameters to the
  *             implementing class
  *  
  * @return A DOM Element    
  */    
    public Element getElement(String[] args) throws Exception;
}
