/*
* Portions of this file Copyright 1999-2005 University of Chicago
* Portions of this file Copyright 1999-2005 The University of Southern California.
*
* This file or a portion of this file is licensed under the
* terms of the Globus Toolkit Public License, found at
* http://www.globus.org/toolkit/download/license.html.
* If you redistribute this file, with or without
* modifications, you must include this notice in the file.
*/
package org.globus.mds.usefulrp.rpprovider;

import org.w3c.dom.Element;

/** 
 * This interface defines a method for performing a abstract transformation process
 * on a given DOM element.  It is intended to be used by classes implementing
 * the <code>ResourcePropertyProviderListener</code> interface, so that an optional 
 * post-processing task can be added to the data generation pipeline. 
 */
public interface ResourcePropertyElementTransform
{
 /** Performs a transform on an input Element
  *
  * @param source A DOM Element to be transformed.
  *
  * @param args An string argument vector to be passed as parameters to the
  *             implementing class
  *  
  * @return The return value type is expected to be a either DOM Element or a 
  *         serializable bean type generated with Axis WSDL2JAVA.    
  */
    public Object transformElement(Element source, String[] args) 
        throws Exception;
}
