/*
* Portions of this file Copyright 1999-2005 University of Chicago
* Portions of this file Copyright 1999-2005 The University of Southern California.
*
* This file or a portion of this file is licensed under the
* terms of the Globus Toolkit Public License, found at
* http://www.globus.org/toolkit/download/license.html.
* If you redistribute this file, with or without
* modifications, you must include this notice in the file.
*/
package org.globus.mds.usefulrp.rpprovider.producers;

import org.globus.wsrf.utils.XmlUtils;

import org.w3c.dom.Document;
import org.w3c.dom.Element;

import java.io.InputStream;
import java.io.FileInputStream;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;

import org.globus.mds.usefulrp.rpprovider.ResourcePropertyElementProducer;

/**
 * A <code>ResourcePropertyElementProducer</code> which reads XML from a file.
*/

public class FileElementProducer implements ResourcePropertyElementProducer
{

    private static Log logger =
            LogFactory.getLog(FileElementProducer.class.getName());
    
    /** Creates a new instance of FileElementProducer */
    public FileElementProducer() {
        
    }
    
    public Element getElement(String[] args) throws Exception
    {
        if ((args == null) || ((args != null) && (args.length == 0))) {
             throw new IllegalArgumentException("Arguments cannot be null!");
        }
        
        InputStream input = null;
        Document doc = null;
        String fileName = args[0]; // for now this is the only argument
        
        try 
        {
	    doc = XmlUtils.newDocument(new FileInputStream(fileName));
        }
        catch (Exception e)
        {
            throw new Exception ("Exception parsing " + fileName + ": " + e);
        } 

        return doc.getDocumentElement();                    
    }
      
}
