/*
* Portions of this file Copyright 1999-2005 University of Chicago
* Portions of this file Copyright 1999-2005 The University of Southern California.
*
* This file or a portion of this file is licensed under the
* terms of the Globus Toolkit Public License, found at
* http://www.globus.org/toolkit/download/license.html.
* If you redistribute this file, with or without
* modifications, you must include this notice in the file.
*/
package org.globus.mds.usefulrp.rpprovider.producers;

import org.globus.wsrf.utils.XmlUtils;

import org.w3c.dom.Document;
import org.w3c.dom.Element;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;

import org.globus.wsrf.container.ServiceHost;
import org.globus.wsrf.config.ContainerConfig;

import org.globus.mds.usefulrp.rpprovider.ResourcePropertyElementProducer;

/** 
 *  Convenience class for executing GRAM scheduler info providers.  This class 
 *  makes the following assumptions about the argument vector:  arg[0] is the 
 *  name of the scheduler provider script to execute, relative to the base 
 *  GLOBUS_LOCATION, and arg [1] is an optional container base URL which is passed 
 *  as a parameter to the executed subprocess. If  arg[1] is not specified, 
 *  it will default to the base URL of the current container instance.
*/

public class SchedulerInfoElementProducer extends ExternalProcessElementProducer
{

    private static Log logger =
            LogFactory.getLog(SchedulerInfoElementProducer.class.getName());

    public SchedulerInfoElementProducer() {
        
    }
    
    public Element getElement(String[] args) throws Exception
    {
        if ((args == null) || ((args != null) && (args.length == 0))) {
             throw new IllegalArgumentException("Arguments cannot be null!");
        }
        
        String file = null;
        String param = null;
        
        if (args.length > 0) {
            file = ContainerConfig.getBaseDirectory() + "/" + args[0];
        }
        if (args.length > 1) {
            param = args[1];
        } else {
            param = ServiceHost.getBaseURL().toString();
        }
        
        String[] newArgs = new String[] { file, param };
        
        return super.getElement(newArgs);
    }
      
}
